package com.sun.im.provider.sample;

import org.netbeans.lib.collab.util.*;
import java.io.*;
import java.util.*;
import com.sun.im.provider.*;


public class SampleMessageConverter extends MessageConverter
{

    private final Properties replacementList = new Properties();

    private static final String CONVERSION_PROPERTIES = "/conversion.properties";

    private static boolean DEBUG = StringUtility.getBoolean(System.getProperty("com.sun.im.provider.sample.SampleMessageConverter.debug"), false);

    public SampleMessageConverter() {
        debug("ENTERING -- SampleMessageConverter()");
        try {
            InputStream stream = getClass().getResourceAsStream(CONVERSION_PROPERTIES);
            debug("InputStream:  " + stream);
            if (stream != null) {
                replacementList.load(stream); 
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        debug("EXITING -- SampleMessageConverter()");
    }


    public void convert(com.sun.im.service.Message message) throws Exception
    {
	System.err.println("converting " + message.toString());

	String sender = message.getOriginator();
	if (sender.indexOf("jennifer") >= 0) {
	    org.netbeans.lib.collab.AuthorizationException e = 
		new org.netbeans.lib.collab.AuthorizationException("Senders may not be called Jennifer", org.netbeans.lib.collab.AuthorizationException.NOT_ALLOWED);
	    throw e;
	}

	debug("ENTERING -- SampleMessageConverter.convert");
        try {
            String content = message.getContent();
            Enumeration enum = replacementList.propertyNames();
            while (enum.hasMoreElements()) {
                String key = (String)enum.nextElement();
		if (DEBUG) debug("REPLACING -- " + key + " ==> " + replacementList.getProperty(key));
                content = content.replaceAll(key, replacementList.getProperty(key));
            } 
            message.setContent(content);
            message.setContent(content, "text/html");
        } catch (Exception e) {
            e.printStackTrace();
        }
        debug("EXITING -- SampleMessageConverter.convert");



    }

    private static void debug(String msg) {
        if (DEBUG) {
            System.out.println(msg);
        }
    }


}
